## vulkan-validationlayers 1.1.97

=== CMakeLists.txt ===
# ~~~
# Copyright (c) 2014-2018 Valve Corporation
# Copyright (c) 2014-2018 LunarG, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# ~~~

# CMake project initialization ---------------------------------------------------------------------------------------------------
# This section contains pre-project() initialization, and ends with the project() command.

cmake_minimum_required(VERSION 3.4)

# Apple: Must be set before enable_language() or project() as it may influence configuration of the toolchain and flags.
set(CMAKE_OSX_DEPLOYMENT_TARGET "10.12" CACHE STRING "Minimum OS X deployment version")

project(Vulkan-ValidationLayers)

# User-interface declarations ----------------------------------------------------------------------------------------------------
# This section contains variables that affect development GUIs (e.g. CMake GUI and IDEs), such as option(), folders, and variables
# with the CACHE property.

# API_NAME allows renaming builds to avoid conflicts with installed SDKs.  It is referenced by layers/vk_loader_platform.h
set(API_NAME "Vulkan" CACHE STRING "API name to use when building")
string(TOLOWER ${API_NAME} API_LOWERCASE)
add_definitions(-DAPI_NAME="${API_NAME}")

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

find_package(PythonInterp 3 REQUIRED)

if (DEFINED Vulkan-Headers_SOURCE_DIR)
    message(STATUS "Using Vulkan headers from ${Vulkan-Headers_SOURCE_DIR}")
    set(VulkanHeaders_INCLUDE_DIR "${Vulkan-Headers_SOURCE_DIR}/include")
    set(VulkanHeaders_INCLUDE_DIRS "${VulkanHeaders_INCLUDE_DIR}")
    set(VulkanRegistry_DIR "${Vulkan-Headers_SOURCE_DIR}/registry")
    set(VulkanRegistry_DIRS "${VulkanRegistry_DIR}")
else()
    find_package(VulkanHeaders)
endif()

option(USE_CCACHE "Use ccache" OFF)
if(USE_CCACHE)
    find_program(CCACHE_FOUND ccache)
    if(CCACHE_FOUND)
        set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE ccache)
    endif()
endif()

set(CMAKE_POSITION_INDEPENDENT_CODE ON)

include(GNUInstallDirs)

if(WIN32 AND CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    # Windows: if install locations not set by user, set install prefix to "<build_dir>\install".
    set(CMAKE_INSTALL_PREFIX "${CMAKE_BINARY_DIR}/install" CACHE PATH "default install path" FORCE)
endif()

if(APPLE)
    # CMake versions 3 or later need CMAKE_MACOSX_RPATH defined. This avoids the CMP0042 policy message.
    set(CMAKE_MACOSX_RPATH 1)
    # The "install" target for MacOS fixes up bundles in place.
    set(CMAKE_INSTALL_PREFIX ${CMAKE_BINARY_DIR})
endif()

# Enable IDE GUI folders
set_property(GLOBAL PROPERTY USE_FOLDERS ON)
# "Helper" targets that don't have interesting source code should set their FOLDER property to this
set(LAYERS_HELPER_FOLDER "Helper Targets")

# Options for Linux only
if(UNIX AND NOT APPLE) # i.e. Linux
    include(FindPkgConfig)
    option(BUILD_WSI_XCB_SUPPORT "Build XCB WSI support" ON)
    option(BUILD_WSI_XLIB_SUPPORT "Build Xlib WSI support" ON)
    option(BUILD_WSI_WAYLAND_SUPPORT "Build Wayland WSI support" ON)
    set(DEMOS_WSI_SELECTION "XCB" CACHE STRING "Select WSI target for demos (XCB, XLIB, WAYLAND, DISPLAY)")

    if(BUILD_WSI_XCB_SUPPORT)
        find_package(XCB REQUIRED)
    endif()

    if(BUILD_WSI_XLIB_SUPPORT)
        find_package(X11 REQUIRED)
    endif()

    if(BUILD_WSI_WAYLAND_SUPPORT)
        find_package(Wayland REQUIRED)
        include_directories(${WAYLAND_CLIENT_INCLUDE_DIR})
    endif()
endif()

# Platform-specific compiler switches
if(CMAKE_COMPILER_IS_GNUCC OR CMAKE_C_COMPILER_ID MATCHES "Clang")
    add_compile_options(-Wall
                        -Wextra
                        -Wno-unused-parameter
                        -Wno-missing-field-initializers
                        -fno-strict-aliasing
                        -fno-builtin-memcmp
                        -fvisibility=hidden)
    set(CMAKE_C_STANDARD 99)
    set(CMAKE_CXX_STANDARD 11)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-rtti")

    # For GCC version 7.1 or greater, we need to disable the implicit fallthrough warning since there's no consistent way to satisfy
    # all compilers until they all accept the C++17 standard.
    if(CMAKE_COMPILER_IS_GNUCC AND NOT (CMAKE_CXX_COMPILER_VERSION LESS 7.1))
        add_compile_options(-Wimplicit-fallthrough=0)
    endif()
elseif(MSVC)
    # Treat warnings as errors
    add_compile_options("/WX")
    # Disable RTTI
    add_compile_options("/GR-")
    # Warn about nested declarations
    add_compile_options("/w34456")
    # Warn about potentially uninitialized variables
    add_compile_options("/w34701")
    add_compile_options("/w34703")
    # Warn about different indirection types.
    add_compile_options("/w34057")
    # Warn about signed/unsigned mismatch.
    add_compile_options("/w34245")
endif()

if(TARGET gtest OR IS_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/external/googletest)
    option(BUILD_TESTS "Build tests" ON)
else()
    option(BUILD_TESTS "Build tests" OFF)
endif()

option(INSTALL_TESTS "Install tests" OFF)
option(BUILD_LAYERS "Build layers" ON)
option(BUILD_LAYER_SUPPORT_FILES "Generate layer files" OFF) # For generating files when not building layers

set(GLSLANG_INSTALL_DIR "GLSLANG-NOTFOUND" CACHE PATH "Absolute path to a glslang install directory")
if(NOT GLSLANG_INSTALL_DIR AND NOT DEFINED ENV{GLSLANG_INSTALL_DIR} AND NOT TARGET glslang)
    message(FATAL_ERROR "Must define location of glslang binaries -- see BUILD.md")
endif()

# GLSLANG_INSTALL_DIR is used as the path to all dependent projects' install dirs
# CMake command line option overrides environment variable
if(NOT GLSLANG_INSTALL_DIR)
    set(GLSLANG_INSTALL_DIR $ENV{GLSLANG_INSTALL_DIR})
endif()

if (NOT TARGET glslang)
    message(STATUS "Using glslang install located at ${GLSLANG_INSTALL_DIR}")
    set(GLSLANG_SEARCH_PATH "${GLSLANG_INSTALL_DIR}/lib")
    set(GLSLANG_DEBUG_SEARCH_PATH "${GLSLANG_INSTALL_DIR}/lib")
    set(GLSLANG_SPIRV_INCLUDE_DIR "${GLSLANG_INSTALL_DIR}/include" CACHE PATH "Path to glslang spirv headers")

    find_library(GLSLANG_LIB NAMES glslang HINTS ${GLSLANG_SEARCH_PATH})
    find_library(OGLCompiler_LIB NAMES OGLCompiler HINTS ${GLSLANG_SEARCH_PATH})
    find_library(OSDependent_LIB NAMES OSDependent HINTS ${GLSLANG_SEARCH_PATH})
    find_library(HLSL_LIB NAMES HLSL HINTS ${GLSLANG_SEARCH_PATH})
    find_library(SPIRV_LIB NAMES SPIRV HINTS ${GLSLANG_SEARCH_PATH})
    find_library(SPIRV_REMAPPER_LIB NAMES SPVRemapper HINTS ${GLSLANG_SEARCH_PATH})

    if(WIN32)
        add_library(glslang STATIC IMPORTED)
        add_library(OGLCompiler STATIC IMPORTED)
        add_library(OSDependent STATIC IMPORTED)
        add_library(HLSL STATIC IMPORTED)
        add_library(SPIRV STATIC IMPORTED)
        add_library(SPVRemapper STATIC IMPORTED)
        add_library(Loader STATIC IMPORTED)

        find_library(GLSLANG_DLIB NAMES glslangd HINTS ${GLSLANG_DEBUG_SEARCH_PATH})
        find_library(OGLCompiler_DLIB NAMES OGLCompilerd HINTS ${GLSLANG_DEBUG_SEARCH_PATH})
        find_library(OSDependent_DLIB NAMES OSDependentd HINTS ${GLSLANG_DEBUG_SEARCH_PATH})
        find_library(HLSL_DLIB NAMES HLSLd HINTS ${GLSLANG_DEBUG_SEARCH_PATH})
        find_library(SPIRV_DLIB NAMES SPIRVd HINTS ${GLSLANG_DEBUG_SEARCH_PATH})
        find_library(SPIRV_REMAPPER_DLIB NAMES SPVRemapperd HINTS ${GLSLANG_DEBUG_SEARCH_PATH})

        set_target_properties(glslang
                              PROPERTIES IMPORTED_LOCATION
                                         "${GLSLANG_LIB}"
                                         IMPORTED_LOCATION_DEBUG
                                         "${GLSLANG_DLIB}")
        set_target_properties(OGLCompiler
                              PROPERTIES IMPORTED_LOCATION
                                         "${OGLCompiler_LIB}"
                                         IMPORTED_LOCATION_DEBUG
                                         "${OGLCompiler_DLIB}")
        set_target_properties(OSDependent
                              PROPERTIES IMPORTED_LOCATION
                                         "${OSDependent_LIB}"
                                         IMPORTED_LOCATION_DEBUG
                                         "${OSDependent_DLIB}")
        set_target_properties(HLSL
                              PROPERTIES IMPORTED_LOCATION
                                         "${HLSL_LIB}"
                                         IMPORTED_LOCATION_DEBUG
                                         "${HLSL_DLIB}")
        set_target_properties(SPIRV
                              PROPERTIES IMPORTED_LOCATION
                                         "${SPIRV_LIB}"
                                         IMPORTED_LOCATION_DEBUG
                                         "${SPIRV_DLIB}")
        set_target_properties(SPVRemapper
                              PROPERTIES IMPORTED_LOCATION
                                         "${SPIRV_REMAPPER_LIB}"
                                         IMPORTED_LOCATION_DEBUG
                                         "${SPIRV_REMAPPER_DLIB}")

        set(GLSLANG_LIBRARIES glslang OGLCompiler OSDependent HLSL SPIRV SPVRemapper ${SPIRV_TOOLS_LIBRARIES})
    else()
        set(GLSLANG_LIBRARIES
            ${GLSLANG_LIB}
            ${OGLCompiler_LIB}
            ${OSDependent_LIB}
            ${HLSL_LIB}
            ${SPIRV_LIB}
            ${SPIRV_REMAPPER_LIB}
            ${SPIRV_TOOLS_LIBRARIES})
    endif()
else()
    set(GLSLANG_SPIRV_INCLUDE_DIR "${glslang_SOURCE_DIR}" CACHE PATH "Path to glslang spirv headers")
    set(GLSLANG_LIBRARIES glslang SPIRV SPVRemapper)
endif()

# spirv-tools
if (NOT TARGET SPIRV-Tools)
    set(SPIRV_TOOLS_BINARY_ROOT "${GLSLANG_INSTALL_DIR}/lib"
        CACHE PATH "User defined path to the SPIRV-Tools binaries for this project")
    set(SPIRV_TOOLS_OPT_BINARY_ROOT "${GLSLANG_INSTALL_DIR}/lib"
        CACHE PATH "User defined path to the SPIRV-Tools-opt binaries for this project")
    set(SPIRV_TOOLS_INCLUDE_DIR "${GLSLANG_INSTALL_DIR}/include" CACHE PATH "Path to spirv tools headers")
    set(SPIRV_TOOLS_SEARCH_PATH "${GLSLANG_INSTALL_DIR}/lib")
    set(SPIRV_TOOLS_DEBUG_SEARCH_PATH "${GLSLANG_INSTALL_DIR}/lib")
    set(SPIRV_TOOLS_OPT_SEARCH_PATH "${GLSLANG_INSTALL_DIR}/lib")
    set(SPIRV_TOOLS_OPT_DEBUG_SEARCH_PATH "${GLSLANG_INSTALL_DIR}/lib")

    find_library(SPIRV_TOOLS_LIB NAMES SPIRV-Tools HINTS ${SPIRV_TOOLS_SEARCH_PATH})
    find_library(SPIRV_TOOLS_OPT_LIB NAMES SPIRV-Tools-opt HINTS ${SPIRV_TOOLS_OPT_SEARCH_PATH})

    if(WIN32)
        add_library(SPIRV-Tools-opt STATIC IMPORTED)
        add_library(SPIRV-Tools STATIC IMPORTED)

        find_library(SPIRV_TOOLS_DLIB NAMES SPIRV-Toolsd HINTS ${SPIRV_TOOLS_DEBUG_SEARCH_PATH})
        find_library(SPIRV_TOOLS_OPT_DLIB NAMES SPIRV-Tools-optd HINTS ${SPIRV_TOOLS_OPT_DEBUG_SEARCH_PATH})

        set_target_properties(SPIRV-Tools
                              PROPERTIES IMPORTED_LOCATION
                                         "${SPIRV_TOOLS_LIB}"
                                         IMPORTED_LOCATION_DEBUG
                                         "${SPIRV_TOOLS_DLIB}")
        set_target_properties(SPIRV-Tools-opt
                              PROPERTIES IMPORTED_LOCATION
                                         "${SPIRV_TOOLS_OPT_LIB}"
                                         IMPORTED_LOCATION_DEBUG
                                         "${SPIRV_TOOLS_OPT_DLIB}")

        set(SPIRV_TOOLS_LIBRARIES SPIRV-Tools-opt SPIRV-Tools)

=== layers/CMakeLists.txt ===
# ~~~
# Copyright (c) 2014-2018 Valve Corporation
# Copyright (c) 2014-2018 LunarG, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# ~~~

if(WIN32)
    add_definitions(-DVK_USE_PLATFORM_WIN32_KHR -DVK_USE_PLATFORM_WIN32_KHX -DWIN32_LEAN_AND_MEAN)
    add_custom_target(mk_layer_config_dir ALL
                      COMMAND ${CMAKE_COMMAND} -E make_directory ${CMAKE_CURRENT_BINARY_DIR}/$<CONFIG>)
    set_target_properties(mk_layer_config_dir PROPERTIES FOLDER ${LAYERS_HELPER_FOLDER})
elseif(ANDROID)
    add_definitions(-DVK_USE_PLATFORM_ANDROID_KHR -DVK_USE_PLATFORM_ANDROID_KHX)
elseif(APPLE)
    add_definitions(-DVK_USE_PLATFORM_MACOS_MVK)
    if(CMAKE_GENERATOR MATCHES "^Xcode.*")
        add_custom_target(mk_layer_config_dir ALL
                          COMMAND ${CMAKE_COMMAND} -E make_directory ${CMAKE_CURRENT_BINARY_DIR}/$<CONFIG>)
    endif()
elseif(UNIX AND NOT APPLE) # i.e. Linux
    if(BUILD_WSI_XCB_SUPPORT)
        add_definitions(-DVK_USE_PLATFORM_XCB_KHR -DVK_USE_PLATFORM_XCB_KHX)
    endif()

    if(BUILD_WSI_XLIB_SUPPORT)
        add_definitions(-DVK_USE_PLATFORM_XLIB_KHR -DVK_USE_PLATFORM_XLIB_KHX -DVK_USE_PLATFORM_XLIB_XRANDR_EXT)
    endif()

    if(BUILD_WSI_WAYLAND_SUPPORT)
        add_definitions(-DVK_USE_PLATFORM_WAYLAND_KHR -DVK_USE_PLATFORM_WAYLAND_KHX)
    endif()
else()
    message(FATAL_ERROR "Unsupported Platform!")
endif()

# Custom targets for generated validation layer helper file dependencies
add_custom_target(spirv_tools_revision_file DEPENDS spirv_tools_commit_id.h)
set_target_properties(spirv_tools_revision_file PROPERTIES FOLDER ${LAYERS_HELPER_FOLDER})

if(BUILD_LAYERS)
    # generate header file containing commit IDs of external dependencies
    add_custom_command(OUTPUT spirv_tools_commit_id.h
                       COMMAND ${PYTHON_EXECUTABLE} ${SCRIPTS_DIR}/external_revision_generator.py
                               --from_uuid -s SPIRV_TOOLS_COMMIT_ID -o spirv_tools_commit_id.h
                       DEPENDS ${SCRIPTS_DIR}/external_revision_generator.py)
endif()

# Configure installation of source files that are dependencies of other repos.
set(LAYER_UTIL_FILES
    hash_util.h
    hash_vk_types.h
    vk_format_utils.h
    vk_format_utils.cpp
    vk_layer_config.h
    vk_layer_config.cpp
    vk_layer_data.h
    vk_layer_extension_utils.h
    vk_layer_extension_utils.cpp
    vk_layer_logging.h
    vk_layer_utils.h
    vk_layer_utils.cpp
    vk_loader_layer.h
    vk_loader_platform.h
    vk_validation_error_messages.h
    ${PROJECT_BINARY_DIR}/vk_layer_dispatch_table.h
    ${PROJECT_BINARY_DIR}/vk_dispatch_table_helper.h
    ${PROJECT_BINARY_DIR}/vk_safe_struct.h
    ${PROJECT_BINARY_DIR}/vk_safe_struct.cpp
    ${PROJECT_BINARY_DIR}/vk_enum_string_helper.h
    ${PROJECT_BINARY_DIR}/vk_object_types.h
    ${PROJECT_BINARY_DIR}/vk_extension_helper.h
    ${PROJECT_BINARY_DIR}/vk_typemap_helper.h)
install(FILES ${LAYER_UTIL_FILES} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

set(TARGET_NAMES
    VkLayer_core_validation
    VkLayer_object_lifetimes
    VkLayer_unique_objects
    VkLayer_stateless_validation
    VkLayer_standard_validation
    VkLayer_thread_safety)

# Install the layer json files
if(WIN32)
    if(CMAKE_GENERATOR MATCHES "^Visual Studio.*")
        foreach(TARGET_NAME ${TARGET_NAMES})
            install(FILES ${CMAKE_CURRENT_BINARY_DIR}/$<CONFIG>/${TARGET_NAME}.json DESTINATION ${CMAKE_INSTALL_LIBDIR})
        endforeach()
    else()
        foreach(TARGET_NAME ${TARGET_NAMES})
            install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${TARGET_NAME}.json DESTINATION ${CMAKE_INSTALL_LIBDIR})
        endforeach()
    endif()
elseif(UNIX) # UNIX includes APPLE
    foreach(TARGET_NAME ${TARGET_NAMES})
        install(FILES ${CMAKE_CURRENT_BINARY_DIR}/staging-json/${TARGET_NAME}.json
                DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/vulkan/explicit_layer.d)
    endforeach()
endif()

# System-specific macros to create a library target.
if(WIN32)
    macro(AddVkLayer target LAYER_COMPILE_DEFINITIONS)
        file(TO_NATIVE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/VkLayer_${target}.def DEF_FILE)
        add_custom_target(copy-${target}-def-file ALL
                          COMMAND ${CMAKE_COMMAND} -E copy_if_different ${DEF_FILE} VkLayer_${target}.def
                          VERBATIM)
        set_target_properties(copy-${target}-def-file PROPERTIES FOLDER ${LAYERS_HELPER_FOLDER})

        add_library(VkLayer_${target} SHARED ${ARGN} VkLayer_${target}.def)
        target_compile_definitions(VkLayer_${target} PUBLIC ${LAYER_COMPILE_DEFINITIONS})
        target_link_libraries(VkLayer_${target} PRIVATE VkLayer_utils)
        add_dependencies(VkLayer_${target} VulkanVL_generate_helper_files VulkanVL_generate_chassis_files VkLayer_utils)
        install(TARGETS VkLayer_${target} DESTINATION ${CMAKE_INSTALL_LIBDIR})
    endmacro()
elseif(APPLE)
    macro(AddVkLayer target LAYER_COMPILE_DEFINITIONS)
        add_library(VkLayer_${target} SHARED ${ARGN})
        target_compile_definitions(VkLayer_${target} PUBLIC ${LAYER_COMPILE_DEFINITIONS})
        target_link_libraries(VkLayer_${target} PRIVATE VkLayer_utils)
        add_dependencies(VkLayer_${target} VulkanVL_generate_helper_files VulkanVL_generate_chassis_files VkLayer_utils)
        set_target_properties(VkLayer_${target}
                              PROPERTIES LINK_FLAGS
                                         "-Wl"
                                         INSTALL_RPATH
                                         "@loader_path/")
        install(TARGETS VkLayer_${target} DESTINATION ${CMAKE_CURRENT_BINARY_DIR})
    endmacro()
else(UNIX AND NOT APPLE) # i.e.: Linux
    macro(AddVkLayer target LAYER_COMPILE_DEFINITIONS)
        add_library(VkLayer_${target} SHARED ${ARGN})
        target_compile_definitions(VkLayer_${target} PUBLIC ${LAYER_COMPILE_DEFINITIONS})
        target_link_libraries(VkLayer_${target} PRIVATE VkLayer_utils)
        add_dependencies(VkLayer_${target} VulkanVL_generate_helper_files VulkanVL_generate_chassis_files VkLayer_utils)
        set_target_properties(VkLayer_${target} PROPERTIES LINK_FLAGS "-Wl,-Bsymbolic,--exclude-libs,ALL")
        install(TARGETS VkLayer_${target} DESTINATION ${CMAKE_INSTALL_LIBDIR})
    endmacro()
endif()

include_directories(${CMAKE_CURRENT_SOURCE_DIR} ${VulkanHeaders_INCLUDE_DIR})

if(WIN32)
    # Applies to all configurations
    add_definitions(-D_CRT_SECURE_NO_WARNINGS)
    # Avoid: fatal error C1128: number of sections exceeded object file format limit: compile with /bigobj
    set_source_files_properties(core_validation.cpp
                                thread_safety.cpp
                                parameter_validation_utils.cpp
                                unique_objects.cpp
                                chassis.cpp
                                PROPERTIES
                                COMPILE_FLAGS
                                "/bigobj")
    # Turn off transitional "changed behavior" warning message for Visual Studio versions prior to 2015. The changed behavior is
    # that constructor initializers are now fixed to clear the struct members.
    add_compile_options("$<$<AND:$<CXX_COMPILER_ID:MSVC>,$<VERSION_LESS:$<CXX_COMPILER_VERSION>,19>>:/wd4351>")
else()
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wpointer-arith -Wno-unused-function -Wno-sign-compare")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wpointer-arith -Wno-unused-function -Wno-sign-compare")
endif()

# Clang warns about unused const variables. Generated files may purposely contain unused consts, so silence this warning in Clang
if(CMAKE_C_COMPILER_ID MATCHES "Clang")
    set_source_files_properties(parameter_validation.cpp PROPERTIES COMPILE_FLAGS "-Wno-unused-const-variable")
endif()

GenerateFromVkXml(thread_safety_generator.py thread_safety.h)
GenerateFromVkXml(thread_safety_generator.py thread_safety.cpp)
GenerateFromVkXml(parameter_validation_generator.py parameter_validation.cpp)
GenerateFromVkXml(parameter_validation_generator.py parameter_validation.h)
GenerateFromVkXml(dispatch_table_helper_generator.py vk_dispatch_table_helper.h)
GenerateFromVkXml(object_tracker_generator.py object_tracker.cpp)
GenerateFromVkXml(object_tracker_generator.py object_tracker.h)
GenerateFromVkXml(layer_chassis_generator.py chassis.cpp)
GenerateFromVkXml(layer_chassis_generator.py chassis.h)
GenerateFromVkXml(layer_chassis_dispatch_generator.py layer_chassis_dispatch.h)
GenerateFromVkXml(layer_chassis_dispatch_generator.py layer_chassis_dispatch.cpp)

# This target causes the chassis source files to be generated.
add_custom_target(VulkanVL_generate_chassis_files
                  DEPENDS chassis.cpp
                          chassis.h
                          layer_chassis_dispatch.h
                          layer_chassis_dispatch.cpp)
set_target_properties(VulkanVL_generate_chassis_files PROPERTIES FOLDER ${LAYERS_HELPER_FOLDER})

if(BUILD_LAYERS)
    AddVkLayer(core_validation "" core_validation.cpp convert_to_renderpass2.cpp descriptor_sets.cpp buffer_validation.cpp shader_validation.cpp xxhash.c)
    AddVkLayer(object_lifetimes "BUILD_OBJECT_TRACKER" object_tracker.cpp object_tracker.h object_tracker_utils.cpp chassis.cpp layer_chassis_dispatch.cpp)
    AddVkLayer(thread_safety "BUILD_THREAD_SAFETY" thread_safety.cpp thread_safety.h chassis.cpp layer_chassis_dispatch.cpp)
    AddVkLayer(unique_objects "LAYER_CHASSIS_CAN_WRAP_HANDLES" chassis.cpp layer_chassis_dispatch.cpp)
    AddVkLayer(stateless_validation "BUILD_PARAMETER_VALIDATION" parameter_validation.cpp parameter_validation.h parameter_validation_utils.cpp chassis.cpp layer_chassis_dispatch.cpp)

    # Core validation has additional dependencies
    target_include_directories(VkLayer_core_validation PRIVATE ${GLSLANG_SPIRV_INCLUDE_DIR})
    target_include_directories(VkLayer_core_validation PRIVATE ${SPIRV_TOOLS_INCLUDE_DIR})
    target_link_libraries(VkLayer_core_validation PRIVATE ${SPIRV_TOOLS_LIBRARIES})
    add_dependencies(VkLayer_core_validation spirv_tools_revision_file)
endif()

# The output file needs Unix "/" separators or Windows "\" separators On top of that, Windows separators actually need to be doubled
# because the json format uses backslash escapes
file(TO_NATIVE_PATH "./" RELATIVE_PATH_PREFIX)
string(REPLACE "\\"
               "\\\\"
               RELATIVE_PATH_PREFIX
               "${RELATIVE_PATH_PREFIX}")

# Run each .json.in file through the generator We need to create the generator.cmake script so that the generator can be run at
# compile time, instead of configure time Running at compile time lets us use cmake generator expressions (TARGET_FILE_NAME and
# TARGET_FILE_DIR, specifically)
file(WRITE "${CMAKE_CURRENT_BINARY_DIR}/generator.cmake" "configure_file(\"\${INPUT_FILE}\" \"\${OUTPUT_FILE}\")")
foreach(TARGET_NAME ${TARGET_NAMES})
    set(CONFIG_DEFINES -DINPUT_FILE="${CMAKE_CURRENT_SOURCE_DIR}/json/${TARGET_NAME}.json.in" -DVK_VERSION=1.1.${vk_header_version})
    # If this json file is not a metalayer, get the needed properties from that target
    if(TARGET ${TARGET_NAME})
        set(CONFIG_DEFINES
            ${CONFIG_DEFINES}
            -DOUTPUT_FILE="$<TARGET_FILE_DIR:${TARGET_NAME}>/${TARGET_NAME}.json"
            -DRELATIVE_LAYER_BINARY="${RELATIVE_PATH_PREFIX}$<TARGET_FILE_NAME:${TARGET_NAME}>")
        # If this json file is a metalayer, make the output path match core validation, and there is no layer binary file
    else()

=== build-android/cmake/layerlib/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.4.1)

# Validation layers could be built with code from
#    github repo   OR
#    ndk's snapshot
# The file structure for glslang spir-V is different, adding BUILD_IN_NDK variable
set(BUILD_IN_NDK OFF)
if (CMAKE_CURRENT_SOURCE_DIR MATCHES "sources/third_party/vulkan/src")
    set(BUILD_IN_NDK ON)
endif()

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -Wall -Werror \
        -Wno-unused-function -Wno-unused-const-variable \
        -Wno-c++98-compat-pedantic -DVK_PROTOTYPES \
        -DVK_USE_PLATFORM_ANDROID_KHR")

if (BUILD_IN_NDK)
    # NDK directory structure:
    #  $ANDROID_NDK/sources/third_party/
    #        vulkan/src
    #        shaderc/third_party (for glslang & spirv-tools )
    # this build uses combined lib libshaderc.a for libSPIRV-Tools.a purpose
    get_filename_component(SRC_DIR
        "${ANDROID_NDK}/sources/third_party/vulkan/src" ABSOLUTE)
    get_filename_component(EXTERNAL_DIR
        "${SRC_DIR}/../../shaderc/third_party" ABSOLUTE)
    get_filename_component(SPIRV_LIB
        "${SRC_DIR}/../../shaderc/libs/${ANDROID_STL}/${ANDROID_ABI}/libshaderc.a"
        ABSOLUTE)
else ()
    # github directory structure:
    #   ${SRC_DIR}
    #   ${SRC_DIR}/build-android/external (for glslang, spirv-tools & shaderc )
    get_filename_component(SRC_DIR "${CMAKE_CURRENT_SOURCE_DIR}/../../.."  ABSOLUTE)
    set(EXTERNAL_DIR "${SRC_DIR}/build-android/third_party/shaderc/third_party")
    set(SPIRV_LIB
        "${SRC_DIR}/build-android/third_party/shaderc/android_test/obj/local/${ANDROID_ABI}/libSPIRV-Tools.a")
endif()
set(COMMON_DIR "${SRC_DIR}/build-android/generated")

set(CMAKE_CXX_clone "${CMAKE_CXX_FLAGS}")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DVK_USE_PLATFORM_ANDROID_KHR \
        -fvisibility=hidden")
include_directories(${SRC_DIR}/include
                    ${COMMON_DIR}/include
                    ${SRC_DIR}/layers
                    ${SRC_DIR}/loader)
add_library(layer_utils STATIC
        ${SRC_DIR}/layers/vk_layer_config.cpp
        ${SRC_DIR}/layers/vk_layer_extension_utils.cpp
        ${SRC_DIR}/layers/vk_layer_utils.cpp
        ${SRC_DIR}/layers/vk_format_utils.cpp)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_clone}")

# assume shaderc already built externally
add_library(SPIRV-Tools-prebuilt STATIC IMPORTED)
set_target_properties(SPIRV-Tools-prebuilt PROPERTIES IMPORTED_LOCATION
    ${SPIRV_LIB})

# build core_validation layers which including shader validation
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DVK_USE_PLATFORM_ANDROID_KHR \
                     -fvisibility=hidden")
add_library(VkLayer_core_validation SHARED
        ${SRC_DIR}/layers/core_validation.cpp
        ${SRC_DIR}/layers/convert_to_renderpass2.cpp
        ${SRC_DIR}/layers/descriptor_sets.cpp
        ${SRC_DIR}/layers/buffer_validation.cpp
        ${SRC_DIR}/layers/shader_validation.cpp
	    ${SRC_DIR}/layers/xxhash.c)
target_include_directories(VkLayer_core_validation PRIVATE
        ${SRC_DIR}/include
        ${SRC_DIR}/layers
        ${COMMON_DIR}/include
        ${SRC_DIR}/loader
        ${EXTERNAL_DIR}/glslang
        ${EXTERNAL_DIR}/spirv-tools/include)
target_link_libraries(VkLayer_core_validation PRIVATE
        log layer_utils SPIRV-Tools-prebuilt)
if (NOT BUILD_IN_NDK)
    set(SPIRV_OPT_LIB
        "${SRC_DIR}/build-android/third_party/shaderc/android_test/obj/local/${ANDROID_ABI}/libSPIRV-Tools-opt.a")
    add_library(SPIRV-Tools-opt-prebuilt STATIC IMPORTED)
    set_target_properties(SPIRV-Tools-opt-prebuilt PROPERTIES IMPORTED_LOCATION
        ${SPIRV_OPT_LIB})
    target_link_libraries(VkLayer_core_validation PRIVATE
        SPIRV-Tools-opt-prebuilt)
endif()

add_library(VkLayer_parameter_validation SHARED
        ${COMMON_DIR}/include/parameter_validation.cpp
        ${COMMON_DIR}/include/layer_chassis_dispatch.cpp
        ${COMMON_DIR}/include/chassis.cpp
        ${SRC_DIR}/layers/parameter_validation_utils.cpp)
target_compile_definitions(VkLayer_parameter_validation PUBLIC "BUILD_PARAMETER_VALIDATION")
target_include_directories(VkLayer_parameter_validation PRIVATE
        ${SRC_DIR}/include
        ${COMMON_DIR}/include
        ${SRC_DIR}/layers
        ${SRC_DIR}/loader)
target_link_libraries(VkLayer_parameter_validation PRIVATE log layer_utils)

add_library(VkLayer_object_tracker SHARED
        ${COMMON_DIR}/include/object_tracker.cpp
        ${COMMON_DIR}/include/layer_chassis_dispatch.cpp
        ${COMMON_DIR}/include/chassis.cpp
        ${SRC_DIR}/layers/object_tracker_utils.cpp)
target_compile_definitions(VkLayer_object_tracker PUBLIC "BUILD_OBJECT_TRACKER")
target_include_directories(VkLayer_object_tracker PRIVATE
        ${SRC_DIR}/include
        ${SRC_DIR}/layers
        ${COMMON_DIR}/include
        ${SRC_DIR}/loader)
target_link_libraries(VkLayer_object_tracker PRIVATE log layer_utils)

add_library(VkLayer_threading SHARED
        ${COMMON_DIR}/include/thread_safety.cpp
        ${COMMON_DIR}/include/layer_chassis_dispatch.cpp
        ${COMMON_DIR}/include/chassis.cpp
target_compile_definitions(VkLayer_threading PUBLIC "BUILD_THREAD_SAFETY")
target_include_directories(VkLayer_threading PRIVATE
        ${SRC_DIR}/include
        ${SRC_DIR}/layers
        ${COMMON_DIR}/include
        ${SRC_DIR}/loader)
target_link_libraries(VkLayer_threading PRIVATE log layer_utils)

add_library(VkLayer_unique_objects SHARED
        ${COMMON_DIR}/include/layer_chassis_dispatch.cpp)
        ${COMMON_DIR}/include/chassis.cpp)
target_compile_definitions(VkLayer_object_tracker PUBLIC "LAYER_CHASSIS_CAN_WRAP_HANDLES")
target_include_directories(VkLayer_unique_objects PRIVATE
        ${SRC_DIR}/include
        ${SRC_DIR}/layers
        ${COMMON_DIR}/include
        ${SRC_DIR}/loader)
target_link_libraries(VkLayer_unique_objects PRIVATE log layer_utils)

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_clone}")

## vulkan-validationlayers 1.1.82.0

=== debian/changelog ===
vulkan-validationlayers (1.1.82.0-0ubuntu1) cosmic; urgency=medium

  * Sync from Debian.

 -- Timo Aaltonen <tjaalton@debian.org>  Fri, 21 Sep 2018 14:47:34 +0300

vulkan-validationlayers (1.1.82.0-1) experimental; urgency=medium

  * Initial packaging, split from old src:vulkan.

 -- Timo Aaltonen <tjaalton@debian.org>  Fri, 21 Sep 2018 12:46:07 +0300

=== debian/control ===
Source: vulkan-validationlayers
Priority: optional
Maintainer: Debian X Strike Force <debian-x@lists.debian.org>
Uploaders: Timo Aaltonen <tjaalton@debian.org>
Build-Depends: debhelper (>= 11),
 cmake,
 glslang-dev,
 libvulkan-dev (>= 1.1.82.0),
 libwayland-dev,
 libx11-dev,
 libxrandr-dev,
 pkg-config,
 python3,
 spirv-tools,
Standards-Version: 4.2.0
Section: libs
Homepage: https://github.com/KhronosGroup/Vulkan-ValidationLayers
Vcs-Git: https://salsa.debian.org/xorg-team/vulkan/vulkan-validationlayers.git
Vcs-Browser: https://salsa.debian.org/xorg-team/vulkan/vulkan-validationlayers

Package: vulkan-validationlayers
Architecture: linux-any
Depends: ${shlibs:Depends}, ${misc:Depends}
Breaks: vulkan-loader,
 libvulkan1 (<< 1.1.82.0),
Replaces: vulkan-loader,
 libvulkan1 (<< 1.1.82.0),
Multi-Arch: same
Description: Vulkan validation layers
 This project provides the Khronos official Vulkan validation layers.
 .
 This package includes the loader library.

Package: vulkan-validationlayers-dev
Section: libdevel
Architecture: linux-any
Depends:
 vulkan-validationlayers (= ${binary:Version}),
 ${misc:Depends},
Breaks:
 libvulkan-dev (<< 1.1.82.0),
Replaces:
 libvulkan-dev (<< 1.1.82.0),
Multi-Arch: same
Description: Vulkan validation layers -- development files
 This project provides the Khronos official Vulkan validation layers.
 .
 This package includes files needed for development.

=== debian/watch ===
version=4
opts="repack,filenamemangle=s/(?:.*?)?v?(\d[\d.]*)\.tar\.gz/vulkan-validationlayers-$1.tar.gz/" \
 https://github.com/KhronosGroup/Vulkan-ValidationLayers/tags (?:.*?/)sdk[_-](\d[\d.]*)\.tar\.gz

## vulkan-validationlayers 1.1.97

=== debian/changelog ===
vulkan-validationlayers (1.1.97-2) unstable; urgency=medium

  * copyright: Updated. (Closes: #919686)

 -- Timo Aaltonen <tjaalton@debian.org>  Sat, 19 Jan 2019 10:14:16 +0200

vulkan-validationlayers (1.1.97-1) experimental; urgency=medium

  * New upstream release.
  * watch: Use new tag naming.
  * control: Bump libvulkan-dev, glslang-dev and spirv-tools build-deps.
  * use-mxgot-for-mips64.patch: Dropped, upstream.
  * fix_shared.patch: Refreshed.

 -- Timo Aaltonen <tjaalton@debian.org>  Sun, 13 Jan 2019 20:06:28 +0200

=== debian/control ===
--- 
+++ 
@@ -4,14 +4,14 @@
 Uploaders: Timo Aaltonen <tjaalton@debian.org>
 Build-Depends: debhelper (>= 11),
  cmake,
- glslang-dev,
- libvulkan-dev (>= 1.1.82.0),
+ glslang-dev (>= 7.10.2984),
+ libvulkan-dev (>= 1.1.97),
  libwayland-dev,
  libx11-dev,
  libxrandr-dev,
  pkg-config,
  python3,
- spirv-tools,
+ spirv-tools (>= 2019.1),
 Standards-Version: 4.2.0
 Section: libs
 Homepage: https://github.com/KhronosGroup/Vulkan-ValidationLayers

=== debian/rules ===
#!/usr/bin/make -f

# see EXAMPLES in dpkg-buildflags(1) and read /usr/share/dpkg/*
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

%:
	dh $@ --builddirectory=build/

override_dh_clean:
	dh_clean
	rm -rf scripts/__pycache__

override_dh_auto_configure:
	dh_auto_configure -- \
	-DCMAKE_BUILD_TYPE=Release \
	-DGLSLANG_INSTALL_DIR=/usr/bin \
        -DCMAKE_INSTALL_INCLUDEDIR=/usr/include/vulkan/

override_dh_auto_install:
	dh_auto_install --destdir=debian/tmp

	rm -f debian/tmp/usr/include/vulkan/*.cpp

override_dh_missing:
	dh_missing --fail-missing

=== debian/watch ===
version=4
opts="repack,filenamemangle=s/(?:.*?)?v?(\d[\d.]*)\.tar\.gz/vulkan-validationlayers-$1.tar.gz/" \
 https://github.com/KhronosGroup/Vulkan-ValidationLayers/tags (?:.*?/)v(\d[\d.]*)\.tar\.gz

## vulkan-validationlayers 1.1.101.0

=== debian/changelog ===
vulkan-validationlayers (1.1.101.0-1) unstable; urgency=medium

  * New upstream release.
  * watch: Use proper tag names.
  * control: Bump glslang-dev and spirv-tools build-depends.

 -- Timo Aaltonen <tjaalton@debian.org>  Tue, 12 Mar 2019 11:37:05 +0200

=== debian/control ===
--- 
+++ 
@@ -4,14 +4,14 @@
 Uploaders: Timo Aaltonen <tjaalton@debian.org>
 Build-Depends: debhelper (>= 11),
  cmake,
- glslang-dev (>= 7.10.2984),
+ glslang-dev (>= 7.11.3113),
  libvulkan-dev (>= 1.1.97),
  libwayland-dev,
  libx11-dev,
  libxrandr-dev,
  pkg-config,
  python3,
- spirv-tools (>= 2019.1),
+ spirv-tools (>= 2019.2),
 Standards-Version: 4.2.0
 Section: libs
 Homepage: https://github.com/KhronosGroup/Vulkan-ValidationLayers

## vulkan-validationlayers 1.1.126.0

=== debian/changelog ===
vulkan-validationlayers (1.1.126.0-1~mx19+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Mon, 23 Mar 2020 22:06:53 -0700

vulkan-validationlayers (1.1.126.0-1) unstable; urgency=medium

  * New upstream release.
  * control: Bump build-deps on libvulkan-dev, spirv-tools.

 -- Timo Aaltonen <tjaalton@debian.org>  Wed, 20 Nov 2019 16:08:33 +0200

vulkan-validationlayers (1.1.114.0-1) unstable; urgency=medium

  * New upstream release.
  * control: Bump libvulkan-dev build-dep.
  * control: Bump glslang-dev and spirv-tools build-deps.
  * rules: Set BUILD_LAYER_SUPPORT_FILES=ON to build headers in this
    version.

 -- Timo Aaltonen <tjaalton@debian.org>  Wed, 11 Sep 2019 15:32:23 +0300

=== debian/control ===
--- 
+++ 
@@ -1,17 +1,18 @@
 Source: vulkan-validationlayers
 Priority: optional
-Maintainer: Debian X Strike Force <debian-x@lists.debian.org>
+Maintainer: Steven Pusser <stevep@mxlinux.org>
+XSBC-Original-Maintainer: Debian X Strike Force <debian-x@lists.debian.org>
 Uploaders: Timo Aaltonen <tjaalton@debian.org>
 Build-Depends: debhelper (>= 11),
  cmake,
- glslang-dev (>= 7.11.3113),
- libvulkan-dev (>= 1.1.97),
+ glslang-dev (>= 7.12.3352),
+ libvulkan-dev (>= 1.1.126.0),
  libwayland-dev,
  libx11-dev,
  libxrandr-dev,
  pkg-config,
  python3,
- spirv-tools (>= 2019.2),
+ spirv-tools (>= 2019.4+git20191022),
 Standards-Version: 4.2.0
 Section: libs
 Homepage: https://github.com/KhronosGroup/Vulkan-ValidationLayers
